//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <dir.h> // fonction fnsplit
#include "Unit1.h"
#include "Unit2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma link "CPortCtl"
#pragma resource "*.dfm"

// (C) Fabrice Sincre ; octobre 2007
// Borland Builder 5
// avec Composant TComPort (gestion RS232)

int j = 0;       // position en cours (abscisse 1   480)
double y ;       // ordonne (0  320)
double vmin[7] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0} ;      // [numro de canal]
double vmin0[7] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0};      // [numro de canal]
double vmax[7] = {5.0,5.0,5.0,5.0,5.0,5.0,5.0} ;      // [numro de canal]
double vmax0[7] = {5.0,5.0,5.0,5.0,5.0,5.0,5.0};       // [numro de canal]
double sdiv = 480.0 , sdiv0 = 480.0 ;     // en secondes
double samplingperiod = 1.000 , samplingperiod0 = 1.000 ;     // en secondes
double deltat[7]={0.625,0.625,0.625,0.625,0.625,0.625,0.625} ;
double deltas ;

double tension_moy [7] ; // moyenne entre deux mises  jour de l'affichage (priode "chantillonnage")
double tension_cumul [7] = {0.0,0.0,0.0,0.0,0.0,0.0,0.0};
int nb_mesures [7]= {0,0,0,0,0,0,0};

double tension_actuelle ;

AnsiString temoinreception = " *"; // clignotement de (*) en cas de rception sur le port COM
bool drapeaureception = false;
bool seconde = true,  seconde0 = true;
bool minute = false,  minute0 = false;
bool heure = false,  heure0 = false;
bool jour = false,  jour0 = false;

char tabulation ='\t';  // tabulation horizontale, code ASCII 0x09
char retour ='\r';      // retour chariot, code ASCII 0x0D
char saut ='\n';        // saut  la ligne, code ASCII 0x0A
int iFileHandle;
bool sauvegardeencours = false ;
AnsiString time0, timebak ="";

unsigned char tableau[1];
        // TX (RS232)  1 octet transmis vers le PIC (numro du canal 0  6)
        // 1er octet transmis: tableau[0]

int numerocanal = 0;      // canal  chantilloner (0  6)
int numerocanal_bak = 0;
int numerocanalaffichage = 0;    // canal  afficher

int resultatconversion[7];      //   resultatconversion[3] -> canal 3
                                //(nb binaire 18 bits, converti en nb entier)
double tension[7];              //   tension[3] = tension du canal 3 (en volts)
double volt[481][7] ;   // volt[182][5] = valeur de la tension du canal 5
                                //  l'abscisse 182
bool premierbalayage = true;
double vrefplus = 5.0;
double vrefmoins = 0.0;
double vrefplus0 = 5.0;
double vrefmoins0 = 0.0;

//---------------------------------------------------------------------------

TForm1 *Form1;

//---------------------------------------------------------------------------
void clearscreen (void)
{
// efface le graphe (en blanc)

Form1->Image1->Canvas->Brush ->Color = clWhite;
Form1->Image1->Canvas->FillRect(Rect(0,0,480,320));
return;
}
//---------------------------------------------------------------------------
void clearscreengauche (void)
{
// efface le demi cran gauche
Form1->Image1->Canvas->Brush ->Color = clWhite;
Form1->Image1->Canvas->FillRect(Rect(0,0,240,320));
return;
}
//---------------------------------------------------------------------------
void clearscreendroite (void)
{
// on efface le demi cran droit
Form1->Image1->Canvas->Brush ->Color = clWhite;
Form1->Image1->Canvas->FillRect(Rect(240,0,480,320));
return;
}
//---------------------------------------------------------------------------
void grillescreen (void)
{
//  trace les grilles du graphe

Form1->Image1->Canvas->Pen->Color = clGreen; // couleur du trait
Form1->Image1->Canvas->Pen->Width = 1; // largeur du trait
Form1->Image1->Canvas->Pen->Style = psDot	; // Style du trait (pointill)

for (int i = 0 ; i<9 ; i++)       // 8 lignes
{
    Form1->Image1->Canvas->MoveTo(0 , 40*i);
    Form1->Image1->Canvas->LineTo(480 , 40*i);
}
for (int i = 0 ; i<13 ; i++)   // 12 colonnes
{
    Form1->Image1->Canvas->MoveTo(40*i , 0);
    Form1->Image1->Canvas->LineTo(40*i , 320);
}

return;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
clearscreen()   ;     // efface le graphe (en blanc)
grillescreen()  ;     //  trace les grilles du graphe
Image1->Canvas->MoveTo(-1000 , 160);



for (int i = 0 ; i<481 ; i++)
{
        volt[i][0] = 0.625;   // initialisation
        volt[i][1] = 1.25;   // initialisation
        volt[i][2] = 1.875;   // initialisation
        volt[i][3] = 2.5;   // initialisation
        volt[i][4] = 3.125;   // initialisation
        volt[i][5] = 3.75;   // initialisation
        volt[i][6] = 4.375;   // initialisation
}
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
// bouton Valider (bote Echelle des tensions)
Timer2->Enabled=false;
Timer3->Enabled=false;
try
{
vmax[numerocanalaffichage] =(Edit1->Text).ToDouble(); //conversion de AnsiString en Double
vmin[numerocanalaffichage] =(Edit2->Text).ToDouble(); //conversion de AnsiString en Double
}
catch(...)
{
vmax[numerocanalaffichage] = vmax0[numerocanalaffichage];
vmin[numerocanalaffichage] = vmin0[numerocanalaffichage];

Edit1->Text = FloatToStrF(vmax[numerocanalaffichage],ffFixed,15,3);
Edit2->Text = FloatToStrF(vmin[numerocanalaffichage],ffFixed,15,3);

Application->MessageBox("Valeur non valide !","Erreur 01",MB_OK);
}

if (vmax[numerocanalaffichage] <= vmin[numerocanalaffichage])
{
        Application->MessageBox ("Vmax doit tre suprieure  Vmin !","Erreur 02",MB_OK);
        vmax[numerocanalaffichage] = vmax0[numerocanalaffichage];
        vmin[numerocanalaffichage] = vmin0[numerocanalaffichage];
}

vmax0[numerocanalaffichage] = vmax[numerocanalaffichage];
vmin0[numerocanalaffichage] = vmin[numerocanalaffichage];

deltat[numerocanalaffichage] = (vmax[numerocanalaffichage] - vmin[numerocanalaffichage])/8.0 ;  // 8 lignes

Edit1->Text = FloatToStrF(vmax[numerocanalaffichage],ffFixed,15,3);
Edit2->Text = FloatToStrF(vmin[numerocanalaffichage],ffFixed,15,3);

Labelx0 -> Caption = FloatToStrF(vmin[numerocanalaffichage],ffFixed,15,3) + " V";
Labelx1 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 1.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx2 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 2.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx3 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 3.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx4 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 4.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx5 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 5.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx6 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 6.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx7 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 7.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx8 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 8.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";

clearscreen()   ;     // efface le graphe (en blanc)
grillescreen()  ;     //  trace les grilles du graphe

if (numerocanalaffichage == 0)
{
        Image1->Canvas->Pen->Color = clRed; // couleur du trait (rouge)
}
if (numerocanalaffichage == 1)
{
        Image1->Canvas->Pen->Color = clBlack; // couleur du trait (noir)
}
if (numerocanalaffichage == 2)
{
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait (bleue)
}
if (numerocanalaffichage == 3)
{
        Image1->Canvas->Pen->Color = clFuchsia; // couleur du trait (fuchsia)
}
if (numerocanalaffichage == 4)
{
        Image1->Canvas->Pen->Color = clGreen	; // couleur du trait (vert)
}
if (numerocanalaffichage == 5)
{
        Image1->Canvas->Pen->Color = clPurple	 ; // couleur du trait (pourpre)
}
if (numerocanalaffichage == 6)
{
        Image1->Canvas->Pen->Color = clNavy	; // couleur du trait (bleu marine)
}

Image1->Canvas->Pen->Width = 2; // largeur du trait

if (j < 240)     // demi cran gauche
{
        Image1->Canvas->MoveTo(240 ,-320.0*(volt[240][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        if (premierbalayage == false)
        {
                for (int i=240 ; i<=480 ; i++)
                {
                        y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                        Image1->Canvas->LineTo(i,y);
                }
        }
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}
else
{
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}
Timer2->Enabled = true;
Timer3->Enabled = true;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
// on arrive ici toute les Te (priode d'chantillonnage = priode de mise  jour de l'affichage)

j++;      // abcisse    1 -> 2 -> ... -> 480 -> 1 > 2 -> ... 
if (j>480)
{
        premierbalayage = false ;
        clearscreengauche () ;  // efface le demi cran gauche
        grillescreen() ;        //  trace les grilles du graphe

        j=1 ;   // retour  gauche
        Image1->Canvas->MoveTo(0 , y);
}
if (j==240)
{

        clearscreendroite () ; // on efface le demi cran droit
        grillescreen() ;        //  trace les grilles du graphe

        Image1->Canvas->MoveTo(239 , y);

}

if (numerocanalaffichage == 0)
{
        Image1->Canvas->Pen->Color = clRed; // couleur du trait (rouge)
}
if (numerocanalaffichage == 1)
{
        Image1->Canvas->Pen->Color = clBlack; // couleur du trait (noir)
}
if (numerocanalaffichage == 2)
{
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait (bleue)
}
if (numerocanalaffichage == 3)
{
        Image1->Canvas->Pen->Color = clFuchsia; // couleur du trait (fuchsia)
}
if (numerocanalaffichage == 4)
{
        Image1->Canvas->Pen->Color = clGreen	; // couleur du trait (vert)
}
if (numerocanalaffichage == 5)
{
        Image1->Canvas->Pen->Color = clPurple	 ; // couleur du trait (pourpre)
}
if (numerocanalaffichage == 6)
{
        Image1->Canvas->Pen->Color = clNavy	; // couleur du trait (bleu marine)
}

Image1->Canvas->Pen->Width = 2; // largeur du trait

for (int i = 0 ; i<7 ;i++)
{
        // i = numro du canal
        if (nb_mesures[i] != 0)
        {
                tension_moy[i] = tension_cumul[i] / nb_mesures[i];
                volt[j][i] = tension_moy[i] ;
        }
        else
        {
                if (j == 1) volt[1][i] = volt[480][i];
                else volt[j][i] = volt[j - 1][i]  ;
                tension_moy[i] = volt[j][i];
        }
}

y =  -320.0*(tension_moy[numerocanalaffichage] - vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);

if (nb_mesures[numerocanalaffichage] !=0)
{
        Image1->Canvas->LineTo(j,y);
}

if (sauvegardeencours == true)
{
        // mise  jour fichier de sauvegarde
        time0 = TimeToStr(Time());
        if (time0 != timebak)   // une sauvegarde par seconde max.
        {
                FileWrite(iFileHandle, DateToStr(Date()).c_str(), DateToStr(Date()).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, time0.c_str(), time0.Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[0] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[0],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[1] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[1],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[2] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[2],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[3] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[3],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[4] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[4],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[5] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[5],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &tabulation, 1);
                FileWrite(iFileHandle, FloatToStrF(tension_moy[6] ,ffFixed,15,3).c_str(), FloatToStrF(tension_moy[6],ffFixed,15,3).Length());
                FileWrite(iFileHandle, &retour, 1);
                FileWrite(iFileHandle, &saut, 1);
        }
        timebak = time0;
}

for (int i = 0 ; i<7 ;i++)
{
        nb_mesures[i] = 0;
        tension_cumul[i] = 0.0;
}
}

//---------------------------------------------------------------------------


void __fastcall TForm1::Button7Click(TObject *Sender)
{
ComPort1->Connected=true;  // ouverture du port
Button7->Enabled=false;
Button8->Enabled=true;
Button6->Enabled=false;
Timer3->Enabled=true;

sauvegardeencours = false;
ButtonSauvegarde->Enabled=true;

Edit1 -> Enabled=true;
Edit2 -> Enabled=true;
Button1 -> Enabled=true;

RadioButtonSecondes -> Enabled=true;
RadioButtonMinutes -> Enabled=true;
RadioButtonHeure -> Enabled=true;
RadioButtonJour -> Enabled=true;
Edit3 -> Enabled=true;
ButtonValidationEchelleTemps -> Enabled=true;

Labelsamplingperiod-> Enabled=true;

EditTension0 -> Enabled=true;
EditTension1 -> Enabled=true;
EditTension2 -> Enabled=true;
EditTension3 -> Enabled=true;
EditTension4 -> Enabled=true;
EditTension5 -> Enabled=true;
EditTension6 -> Enabled=true;

RadioGroupSelectionCourbeCanal -> Enabled = true ;

EditVrefPlus -> Enabled = true ;
EditVrefMoins  -> Enabled = true ;
ButtonValidationEtalonnage  -> Enabled = true ;

clearscreen()   ;     // efface le graphe (en blanc)
grillescreen()  ;     //  trace les grilles du graphe

Image1->Canvas->MoveTo(-1000 , 160);
j = 0;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
ComPort1->Connected=false;  // fermeture du port
Button7->Enabled=true;
Button8->Enabled=false;
Button6->Enabled=true;
Timer3->Enabled=false;

ButtonSauvegarde->Enabled = false ;

Edit1 -> Enabled=false;
Edit2 -> Enabled=false;
Button1 -> Enabled=false;

RadioButtonSecondes -> Enabled=false;
RadioButtonMinutes -> Enabled=false;
RadioButtonHeure -> Enabled=false;
RadioButtonJour -> Enabled=false;
Edit3 -> Enabled=false;
ButtonValidationEchelleTemps -> Enabled=false;

Labelsamplingperiod-> Enabled=false;

EditTension0 -> Enabled=false;
EditTension1 -> Enabled=false;
EditTension2 -> Enabled=false;
EditTension3 -> Enabled=false;
EditTension4 -> Enabled=false;
EditTension5 -> Enabled=false;
EditTension6 -> Enabled=false;

RadioGroupSelectionCourbeCanal -> Enabled = false ;

EditVrefPlus -> Enabled = false ;
EditVrefMoins  -> Enabled = false ;
ButtonValidationEtalonnage  -> Enabled = false ;

if (sauvegardeencours == true)
{
        FileClose(iFileHandle);
        sauvegardeencours = false;
}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
// on arrive ici quand on reoit des donnes du port COM (normalement toutes les 140 ms)

try
{

unsigned char *datarecu = new unsigned char [Count];
ComPort1->Read(datarecu, Count);
// Lit "Count" octet(s) prsent(s) dans le buffer d'entre et le(s) place dans "datarecu"
// Normalement, on reoit trois octets du PIC

        resultatconversion[numerocanal] = datarecu[0]*256*256 + datarecu[1]*256 + datarecu[2];

        tension[numerocanal] = (vrefplus - vrefmoins)*resultatconversion[numerocanal]/(1023.0*256.0) + vrefmoins;

        tension_actuelle =  tension[numerocanal];

        if (numerocanal == 0)
        {
                EditTension0 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 1)
        {
                EditTension1 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 2)
        {
                EditTension2 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 3)
        {
                EditTension3 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 4)
        {
                EditTension4 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 5)
        {
                EditTension5 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        if (numerocanal == 6)
        {
                EditTension6 -> Text =  FloatToStrF(tension[numerocanal],ffFixed,15,3);
        }

        // calcul de la valeur moyenne de la temperature

        nb_mesures[numerocanal]++;
        tension_cumul[numerocanal] =  tension_cumul[numerocanal] + tension_actuelle;

        // tmoin de rception
        drapeaureception = true;

delete [] datarecu;
datarecu = NULL;
}

catch(...)
{
Application->MessageBox("Erreur de rception !","Erreur 04",MB_OK);
}


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
ComPort1->ShowSetupDialog();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
// on arrive ici toutes les 1000 ms

if (drapeaureception == true)
{
        drapeaureception = false ;
        if (temoinreception == "  ") temoinreception = " *";
        else temoinreception = "  ";
}
// affichage de l'heure courante
Label7time->Caption = TimeToStr(Time()) + temoinreception ;   // AnsiString  hh:mm:ss
Label7date->Caption = DateToStr(Date()) ;   // AnsiString

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSauvegardeClick(TObject *Sender)
{
// sauvegarde dans un fichier
if (sauvegardeencours == false)
{
AnsiString entete ="Carte d'acquisition 7 canaux" ;
AnsiString entete0 ="(C) Fabrice SINCERE" ;
AnsiString entete0a ="http://perso.orange.fr/fabrice.sincere" ;
AnsiString entete0b ="Tensions en volts" ;
AnsiString entete1 ="Date       ";
AnsiString entete2 ="Heure      ";
AnsiString entete3 ="Canal0" ;
AnsiString entete4 ="Canal1" ;
AnsiString entete5 ="Canal2" ;
AnsiString entete6 ="Canal3" ;
AnsiString entete7 ="Canal4" ;
AnsiString entete8 ="Canal5" ;
AnsiString entete9 ="Canal6" ;

char szFileName[100];

int iLength;
if (SaveDialog1->Execute())
{
        if (FileExists(SaveDialog1->FileName))
        {
                fnsplit(SaveDialog1->FileName.c_str(), 0, 0, szFileName, 0);
                strcat(szFileName, ".BAK");
                RenameFile(SaveDialog1->FileName, szFileName);
        }
        iFileHandle = FileCreate(SaveDialog1->FileName);

        FileWrite(iFileHandle, entete.c_str(), entete.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete0.c_str(), entete0.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete0a.c_str(), entete0a.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete0b.c_str(), entete0b.Length());
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, entete1.c_str(), entete1.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete2.c_str(), entete2.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete3.c_str(), entete3.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete4.c_str(), entete4.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete5.c_str(), entete5.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete6.c_str(), entete6.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete7.c_str(), entete7.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete8.c_str(), entete8.Length());
        FileWrite(iFileHandle, &tabulation, 1);
        FileWrite(iFileHandle, entete9.c_str(), entete9.Length());

        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);
        FileWrite(iFileHandle, &retour, 1);
        FileWrite(iFileHandle, &saut, 1);

        sauvegardeencours = true ;
        ButtonSauvegarde->Enabled=false;
}
}
}


//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonSchema1Click(TObject *Sender)
{
Form2shema1-> ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
// on arrive ici toutes les 140 ms

if (ComPort1->Connected==true)
{
        numerocanal++;
        if (numerocanal > 6) numerocanal = 0;
        tableau[0]= numerocanal;
        ComPort1->Write(tableau, 1); // Ecrit 1 octet sur le port srie
}        
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RadioGroupSelectionCourbeCanalClick(
      TObject *Sender)
{
// affichage de la courbe de la voie choisie :

numerocanalaffichage = RadioGroupSelectionCourbeCanal -> ItemIndex ;

GroupBox1 -> Caption = "Echelle Canal " + IntToStr(numerocanalaffichage);

Labelx0 -> Caption = FloatToStrF(vmin[numerocanalaffichage],ffFixed,15,3) + " V";
Labelx1 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 1.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx2 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 2.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx3 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 3.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx4 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 4.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx5 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 5.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx6 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 6.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx7 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 7.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";
Labelx8 -> Caption = FloatToStrF(vmin[numerocanalaffichage] + 8.0*deltat[numerocanalaffichage],ffFixed,15,3)+ " V";

Edit1->Text = FloatToStrF(vmax[numerocanalaffichage],ffFixed,15,3);
Edit2->Text = FloatToStrF(vmin[numerocanalaffichage],ffFixed,15,3);

clearscreen()   ;     // efface le graphe (en blanc)
grillescreen()  ;     //  trace les grilles du graphe

if (numerocanalaffichage == 0)
{
        Image1->Canvas->Pen->Color = clRed; // couleur du trait (rouge)
}
if (numerocanalaffichage == 1)
{
        Image1->Canvas->Pen->Color = clBlack; // couleur du trait (noir)
}
if (numerocanalaffichage == 2)
{
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait (bleue)
}
if (numerocanalaffichage == 3)
{
        Image1->Canvas->Pen->Color = clFuchsia; // couleur du trait (fuchsia)
}
if (numerocanalaffichage == 4)
{
        Image1->Canvas->Pen->Color = clGreen	; // couleur du trait (vert)
}
if (numerocanalaffichage == 5)
{
        Image1->Canvas->Pen->Color = clPurple	 ; // couleur du trait (pourpre)
}
if (numerocanalaffichage == 6)
{
        Image1->Canvas->Pen->Color = clNavy	; // couleur du trait (bleu marine)
}

Image1->Canvas->Pen->Width = 2; // largeur du trait

if (j < 240)     // demi cran gauche
{
        Image1->Canvas->MoveTo(240 ,-320.0*(volt[240][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        if (premierbalayage == false)
        {
                for (int i=240 ; i<=480 ; i++)
                {
                        y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                        Image1->Canvas->LineTo(i,y);
                }
        }
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}
else
{
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}

}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonValidationEchelleTempsClick(TObject *Sender)
{
// bouton Valider (bote Echelle des temps)
Timer2->Enabled=false;
Timer3->Enabled=false;
try
{
seconde = RadioButtonSecondes->Checked ;
minute = RadioButtonMinutes->Checked ;
heure =  RadioButtonHeure->Checked ;
jour =  RadioButtonJour->Checked ;

sdiv =(Edit3->Text).ToDouble(); //conversion de AnsiString en Double
}
catch(...)
{
sdiv = sdiv0;
seconde = seconde0;
minute = minute0;
heure = heure0;
jour = jour0;

Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
RadioButtonSecondes->Checked = seconde ;
RadioButtonMinutes->Checked = minute ;
RadioButtonHeure->Checked = heure;
RadioButtonJour->Checked = jour;
Application->MessageBox("Valeur non valide !","Erreur 01",MB_OK);
}

samplingperiod  = sdiv / 480.0 ;    // en s   (480 points en abscisse)
if (RadioButtonMinutes->Checked == true) samplingperiod = samplingperiod*60.0 ;
if (RadioButtonHeure->Checked == true) samplingperiod = samplingperiod*3600.0 ;
if (RadioButtonJour->Checked == true) samplingperiod = samplingperiod*86400.0 ;

if (samplingperiod < 1.0)
{
        Application->MessageBox("La priode doit tre suprieure  480 secondes !","Erreur 03",MB_OK);
        sdiv = sdiv0;
        samplingperiod =  samplingperiod0;
        seconde = seconde0;
        minute = minute0;
        heure = heure0;
        jour = jour0;
}

sdiv0 = sdiv;
samplingperiod0 =  samplingperiod;
seconde0 = seconde;
minute0 = minute;
heure0 = heure;
jour0 = jour;

deltas =  sdiv /12.0 ;        // 12 colonnes

Timer3 -> Interval = samplingperiod*1000.0;    // en millisecondes
Labelsamplingperiod -> Caption = FloatToStrF(samplingperiod,ffFixed,15,3) + " s";

Edit3->Text = FloatToStrF(sdiv,ffFixed,15,2);
RadioButtonSecondes->Checked = seconde ;
RadioButtonMinutes->Checked = minute ;
RadioButtonHeure->Checked = heure;
RadioButtonJour->Checked = jour;

Labelt1 -> Caption = FloatToStrF(1.0*deltas,ffFixed,15,2);
Labelt2 -> Caption = FloatToStrF(2.0*deltas,ffFixed,15,2);
Labelt3 -> Caption = FloatToStrF(3.0*deltas,ffFixed,15,2);
Labelt4 -> Caption = FloatToStrF(4.0*deltas,ffFixed,15,2);
Labelt5 -> Caption = FloatToStrF(5.0*deltas,ffFixed,15,2);
Labelt6 -> Caption = FloatToStrF(6.0*deltas,ffFixed,15,2);
Labelt7 -> Caption = FloatToStrF(7.0*deltas,ffFixed,15,2);
Labelt8 -> Caption = FloatToStrF(8.0*deltas,ffFixed,15,2);
Labelt9 -> Caption = FloatToStrF(9.0*deltas,ffFixed,15,2);
Labelt10 -> Caption = FloatToStrF(10.0*deltas,ffFixed,15,2);
Labelt11 -> Caption = FloatToStrF(11.0*deltas,ffFixed,15,2);
Labelt12 -> Caption = FloatToStrF(12.0*deltas,ffFixed,15,2);

if (RadioButtonSecondes->Checked == true) LabelUniteTemps -> Caption = "secondes";
if (RadioButtonMinutes->Checked == true) LabelUniteTemps -> Caption = "minutes";
if (RadioButtonHeure->Checked == true)
{
        if (sdiv < 2.0) LabelUniteTemps -> Caption = "heure";
        else LabelUniteTemps -> Caption = "heures";
}
if (RadioButtonJour->Checked == true)
{
        if (sdiv < 2.0) LabelUniteTemps -> Caption = "jour";
        else LabelUniteTemps -> Caption = "jours";
}

clearscreen ();         // efface le graphe (en blanc)
grillescreen ();        //  trace les grilles du graphe
Image1->Canvas->MoveTo(-1000 , 160);
j=0 ;
premierbalayage = true;
Timer2->Enabled=true;
Timer3->Enabled=true;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonValidationEtalonnageClick(TObject *Sender)
{
// bouton Valider (bote Etalonnage)
Timer2->Enabled=false;
Timer3->Enabled=false;
try
{
vrefplus =(EditVrefPlus->Text).ToDouble(); //conversion de AnsiString en Double
vrefmoins =(EditVrefMoins->Text).ToDouble(); //conversion de AnsiString en Double
}
catch(...)
{
vrefplus = vrefplus0;
vrefmoins = vrefmoins0;

EditVrefPlus->Text = FloatToStrF(vrefplus,ffFixed,15,3);
EditVrefMoins->Text = FloatToStrF(vrefmoins,ffFixed,15,3);

Application->MessageBox("Valeur non valide !","Erreur 01",MB_OK);
}

if (vrefplus <= vrefmoins)
{
        Application->MessageBox ("V REF+ doit tre suprieure  V REF - !","Erreur 02",MB_OK);
        vrefplus = vrefplus0;
        vrefmoins = vrefmoins0;
}

for (int i = 0 ; i<481 ; i++)
{
        for (int k = 0 ; k <7 ; k++)
        {
                volt[i][k] = (vrefplus - vrefmoins)/(vrefplus0 - vrefmoins0)*(volt[i][k] - vrefmoins0)+ vrefmoins ;
        }
}

vrefplus0 = vrefplus;
vrefmoins0 = vrefmoins;

EditVrefPlus->Text = FloatToStrF(vrefplus,ffFixed,15,3);
EditVrefMoins->Text = FloatToStrF(vrefmoins,ffFixed,15,3);

clearscreen()   ;     // efface le graphe (en blanc)
grillescreen()  ;     //  trace les grilles du graphe

if (numerocanalaffichage == 0)
{
        Image1->Canvas->Pen->Color = clRed; // couleur du trait (rouge)
}
if (numerocanalaffichage == 1)
{
        Image1->Canvas->Pen->Color = clBlack; // couleur du trait (noir)
}
if (numerocanalaffichage == 2)
{
        Image1->Canvas->Pen->Color = clBlue; // couleur du trait (bleue)
}
if (numerocanalaffichage == 3)
{
        Image1->Canvas->Pen->Color = clFuchsia; // couleur du trait (fuchsia)
}
if (numerocanalaffichage == 4)
{
        Image1->Canvas->Pen->Color = clGreen	; // couleur du trait (vert)
}
if (numerocanalaffichage == 5)
{
        Image1->Canvas->Pen->Color = clPurple	 ; // couleur du trait (pourpre)
}
if (numerocanalaffichage == 6)
{
        Image1->Canvas->Pen->Color = clNavy	; // couleur du trait (bleu marine)
}

Image1->Canvas->Pen->Width = 2; // largeur du trait

if (j < 240)     // demi cran gauche
{
        Image1->Canvas->MoveTo(240 ,-320.0*(volt[240][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        if (premierbalayage == false)
        {
                for (int i=240 ; i<=480 ; i++)
                {
                        y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                        Image1->Canvas->LineTo(i,y);
                }
        }
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}
else
{
        Image1->Canvas->MoveTo(1 ,-320.0*(volt[1][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]) );
        for (int i=1 ; i<=j ; i++)
        {
                y =  -320.0*(volt[i][numerocanalaffichage]- vmax[numerocanalaffichage])/(vmax[numerocanalaffichage] - vmin[numerocanalaffichage]);
                Image1->Canvas->LineTo(i,y);
        }
}

Timer2->Enabled = true;
Timer3->Enabled = true;
}
//---------------------------------------------------------------------------



